`timescale 10ps / 10ps
`define GTK // use VCD

`define MODULE	tb_clock
`ifdef CLK_LIMIT
`else
`define CLK_LIMIT	20000
`endif

module `MODULE;

   reg [23:0] CLK_COUNT;
   reg CLK;   // input
   reg BTN_SEL; // input
   reg BTN_UP; // input
   reg BTN_DN; // input

clock # ( .CLK_HZ(1024) ) top
	( .CLK(CLK) 
		, .BTN_SEL(BTN_SEL)
		, .BTN_UP(BTN_UP)
		, .BTN_DN(BTN_DN)
		, .CLK_OUT(CLK_OUT)
		, .A(A)
		, .B(B)
		, .C(C)
		, .D(D)
		, .E(E)
		, .F(F)
		, .G(G)
		, .DIG1(DIG1)
		, .DIG2(DIG2)
		, .DIG3(DIG3)
		, .DIG4(DIG4)
		, .CLK_1HZ(CLK_1HZ)
		);

   parameter CLKP = 5000000;        //  50us
   parameter CLKH = CLKP/2;      //
   parameter CLKL = CLKP-CLKH;   //
   
   always begin
      #CLKH CLK = 0;
      #CLKL CLK = 1;
   end

`ifdef GTK
   initial begin
      $dumpfile("tb.vcd");
      $dumpvars(0,`MODULE.top);
   end
`endif

   initial begin : test
      CLK_COUNT = 0;
      BTN_SEL = 1'b0;
      BTN_UP = 1'b0;
      BTN_DN = 1'b0;
      //sys_reset();
      while ( (CLK_COUNT < `CLK_LIMIT) )
      begin
         @(posedge CLK);
         CLK_COUNT = CLK_COUNT + 1;
	 if (CLK_COUNT == 100) BTN_SEL = 1'b1;
	 if (CLK_COUNT == 200) BTN_SEL = 1'b0;
	 if (CLK_COUNT == 300) BTN_UP = 1'b1;
	 if (CLK_COUNT == 350) BTN_UP = 1'b0;
	 if (CLK_COUNT == 400) BTN_UP = 1'b1;
	 if (CLK_COUNT == 450) BTN_UP = 1'b0;
	 if (CLK_COUNT == 500) BTN_UP = 1'b1;
	 if (CLK_COUNT == 550) BTN_UP = 1'b0;
      end
//      @(posedge CLK);
      #1
      $display("*** Simulation Complete! ***");
      $finish;
   end

   task sys_reset;
      begin
         //PC2 = 0;
         //#1 RESET = 1;
         //CLK2X = 0;
         @(posedge CLK);
         @(posedge CLK);
         //#1 RESET = 0;
         @(posedge CLK);
         @(posedge CLK);
         CLK_COUNT = CLK_COUNT + 1;
      end
   endtask // sys_reset
   
endmodule // test
